Loading...
Searching...
No Matches
juce::dsp::SIMDRegister< Type > Struct Template Reference

## Detailed Description

template<typename Type>
struct juce::dsp::SIMDRegister< Type >

A wrapper around the platform's native SIMD register type.

This class is only available on SIMD machines. Use JUCE_USE_SIMD to query if SIMD is available for your system.

SIMDRegister<Type> is a templated class representing the native vectorized version of FloatingType. SIMDRegister supports all numerical primitive types and std:complex<float> and std::complex<double> supports and most operations of the corresponding primitive type. Additionally, SIMDRegister can be accessed like an array to extract the individual elements.

If you are using SIMDRegister as a pointer, then you must ensure that the memory is sufficiently aligned for SIMD vector operations. Failing to do so will result in crashes or very slow code. Use SIMDRegister::isSIMDAligned to query if a pointer is sufficiently aligned for SIMD vector operations.

Note that using SIMDRegister without enabling optimizations will result in code with very poor performance.

The documentation for this struct was generated from the following file:

- juce_dsp/containers/juce_SIMDRegister.h

## Classes

struct | ElementAccess

## Public Types

using | ElementType = Type
| The type that represents the individual constituents of the SIMD Register.
using | value_type = ElementType
| STL compatible value_type definition (same as ElementType).
using | MaskType = SIMDInternal::MaskType<ElementType>
| The corresponding primitive integer type, for example, this will be int32_t if type is a float.
using | PrimitiveType = typename SIMDInternal::PrimitiveType<ElementType>::type
| The native primitive type (used internally).
using | NativeOps = SIMDNativeOps<PrimitiveType>
| The native operations for this platform and type combination (used internally).
using | vSIMDType = typename NativeOps::vSIMDType
| The native type (used internally).
using | vMaskType = SIMDRegister<MaskType>
| The corresponding integer SIMDRegister type (used internally).
using | vMaskSIMDType = typename vMaskType::vSIMDType
| The internal native type for the corresponding mask type (used internally).
using | CmplxOps = CmplxSIMDOps<ElementType>
| Wrapper for operations which need to be handled differently for complex and scalar types (used internally).

## Public Member Functions

| SIMDRegister () noexcept=default
| Default constructor.
| SIMDRegister (vSIMDType a) noexcept
| Constructs an object from the native SIMD type.
| SIMDRegister (Type s) noexcept
| Constructs an object from a scalar type by broadcasting it to all elements.
void JUCE_VECTOR_CALLTYPE | copyToRawArray (ElementType *a) const noexcept
| Copies the elements of the SIMDRegister to a scalar array in memory.
ElementType JUCE_VECTOR_CALLTYPE | get (size_t idx) const noexcept
| Returns the idx-th element of the receiver.
void JUCE_VECTOR_CALLTYPE | set (size_t idx, ElementType v) noexcept
| Sets the idx-th element of the receiver.
ElementType JUCE_VECTOR_CALLTYPE | operator[] (size_t idx) const noexcept
| Returns the idx-th element of the receiver.
ElementAccess JUCE_VECTOR_CALLTYPE | operator[] (size_t idx) noexcept
| Returns the idx-th element of the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator+= (SIMDRegister v) noexcept
| Adds another SIMDRegister to the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator-= (SIMDRegister v) noexcept
| Subtracts another SIMDRegister to the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator*= (SIMDRegister v) noexcept
| Multiplies another SIMDRegister to the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator= (ElementType s) noexcept
| Broadcasts the scalar to all elements of the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator+= (ElementType s) noexcept
| Adds a scalar to the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator-= (ElementType s) noexcept
| Subtracts a scalar to the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator*= (ElementType s) noexcept
| Multiplies a scalar to the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator&= (vMaskType v) noexcept
| Bit-and the receiver with SIMDRegister v and store the result in the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator|= (vMaskType v) noexcept
| Bit-or the receiver with SIMDRegister v and store the result in the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator^= (vMaskType v) noexcept
| Bit-xor the receiver with SIMDRegister v and store the result in the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator&= (MaskType s) noexcept
| Bit-and each element of the receiver with the scalar s and store the result in the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator|= (MaskType s) noexcept
| Bit-or each element of the receiver with the scalar s and store the result in the receiver.
SIMDRegister &JUCE_VECTOR_CALLTYPE | operator^= (MaskType s) noexcept
| Bit-xor each element of the receiver with the scalar s and store the result in the receiver.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator+ (SIMDRegister v) const noexcept
| Returns the sum of the receiver and v.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator- (SIMDRegister v) const noexcept
| Returns the difference of the receiver and v.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator* (SIMDRegister v) const noexcept
| Returns the product of the receiver and v.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator+ (ElementType s) const noexcept
| Returns a vector where each element is the sum of the corresponding element in the receiver and the scalar s.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator- (ElementType s) const noexcept
| Returns a vector where each element is the difference of the corresponding element in the receiver and the scalar s.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator* (ElementType s) const noexcept
| Returns a vector where each element is the product of the corresponding element in the receiver and the scalar s.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator& (vMaskType v) const noexcept
| Returns the bit-and of the receiver and v.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator| (vMaskType v) const noexcept
| Returns the bit-or of the receiver and v.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator^ (vMaskType v) const noexcept
| Returns the bit-xor of the receiver and v.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator~ () const noexcept
| Returns a vector where each element is the bit-inverted value of the corresponding element in the receiver.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator& (MaskType s) const noexcept
| Returns a vector where each element is the bit-and'd value of the corresponding element in the receiver and the scalar s.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator| (MaskType s) const noexcept
| Returns a vector where each element is the bit-or'd value of the corresponding element in the receiver and the scalar s.
SIMDRegister JUCE_VECTOR_CALLTYPE | operator^ (MaskType s) const noexcept
| Returns a vector where each element is the bit-xor'd value of the corresponding element in the receiver and the scalar s.
bool JUCE_VECTOR_CALLTYPE | operator== (SIMDRegister other) const noexcept
| Returns true if all element-wise comparisons return true.
bool JUCE_VECTOR_CALLTYPE | operator!= (SIMDRegister other) const noexcept
| Returns true if any element-wise comparisons return false.
bool JUCE_VECTOR_CALLTYPE | operator== (Type s) const noexcept
| Returns true if all elements are equal to the scalar.
bool JUCE_VECTOR_CALLTYPE | operator!= (Type s) const noexcept
| Returns true if any elements are not equal to the scalar.
ElementType | sum () const noexcept
| Returns a scalar which is the sum of all elements of the receiver.

## Static Public Member Functions

static constexpr size_t | size () noexcept
| Returns the number of elements in this vector.
static SIMDRegister JUCE_VECTOR_CALLTYPE | expand (ElementType s) noexcept
| Creates a new SIMDRegister from the corresponding scalar primitive.
static SIMDRegister JUCE_VECTOR_CALLTYPE | fromNative (vSIMDType a) noexcept
| Creates a new SIMDRegister from the internal SIMD type (for example __mm128 for single-precision floating point on SSE architectures).
static SIMDRegister JUCE_VECTOR_CALLTYPE | fromRawArray (const ElementType *a) noexcept
| Creates a new SIMDRegister from the first SIMDNumElements of a scalar array.
static vMaskType JUCE_VECTOR_CALLTYPE | equal (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is equal to the corresponding element of b, or zero otherwise.
static vMaskType JUCE_VECTOR_CALLTYPE | notEqual (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is not equal to the corresponding element of b, or zero otherwise.
static vMaskType JUCE_VECTOR_CALLTYPE | lessThan (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is less than to the corresponding element of b, or zero otherwise.
static vMaskType JUCE_VECTOR_CALLTYPE | lessThanOrEqual (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is than or equal to the corresponding element of b, or zero otherwise.
static vMaskType JUCE_VECTOR_CALLTYPE | greaterThan (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than to the corresponding element of b, or zero otherwise.
static vMaskType JUCE_VECTOR_CALLTYPE | greaterThanOrEqual (SIMDRegister a, SIMDRegister b) noexcept
| Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than or equal to the corresponding element of b, or zero otherwise.
static SIMDRegister JUCE_VECTOR_CALLTYPE | min (SIMDRegister a, SIMDRegister b) noexcept
| Returns a new vector where each element is the minimum of the corresponding element of a and b.
static SIMDRegister JUCE_VECTOR_CALLTYPE | max (SIMDRegister a, SIMDRegister b) noexcept
| Returns a new vector where each element is the maximum of the corresponding element of a and b.
static SIMDRegister JUCE_VECTOR_CALLTYPE | multiplyAdd (SIMDRegister a, const SIMDRegister b, SIMDRegister c) noexcept
| Multiplies b and c and adds the result to a.
static SIMDRegister JUCE_VECTOR_CALLTYPE | truncate (SIMDRegister a) noexcept
| Truncates each element to its integer part.
static SIMDRegister JUCE_VECTOR_CALLTYPE | abs (SIMDRegister a) noexcept
| Returns the absolute value of each element.
static bool | isSIMDAligned (const ElementType *ptr) noexcept
| Checks if the given pointer is sufficiently aligned for using SIMD operations.
static ElementType * | getNextSIMDAlignedPtr (ElementType *ptr) noexcept
| Returns the next position in memory where isSIMDAligned returns true.

## Public Attributes

vSIMDType | value {}

## Static Public Attributes

static constexpr size_t | SIMDRegisterSize = sizeof (vSIMDType)
| The size in bytes of this register.
static constexpr size_t | SIMDNumElements = SIMDRegisterSize / sizeof (ElementType)
| The number of elements that this vector can hold.

## Member Typedef Documentation

## ElementType

template<typename Type>

using juce::dsp::SIMDRegister< Type >::ElementType = Type

The type that represents the individual constituents of the SIMD Register.

## value_type

template<typename Type>

using juce::dsp::SIMDRegister< Type >::value_type = ElementType

STL compatible value_type definition (same as ElementType).

## MaskType

template<typename Type>

using juce::dsp::SIMDRegister< Type >::MaskType = SIMDInternal::MaskType<ElementType>

The corresponding primitive integer type, for example, this will be int32_t if type is a float.

## PrimitiveType

template<typename Type>

using juce::dsp::SIMDRegister< Type >::PrimitiveType = typename SIMDInternal::PrimitiveType<ElementType>::type

The native primitive type (used internally).

## NativeOps

template<typename Type>

using juce::dsp::SIMDRegister< Type >::NativeOps = SIMDNativeOps<PrimitiveType>

The native operations for this platform and type combination (used internally).

## vSIMDType

template<typename Type>

using juce::dsp::SIMDRegister< Type >::vSIMDType = typename NativeOps::vSIMDType

The native type (used internally).

## vMaskType

template<typename Type>

using juce::dsp::SIMDRegister< Type >::vMaskType = SIMDRegister<MaskType>

The corresponding integer SIMDRegister type (used internally).

## vMaskSIMDType

template<typename Type>

using juce::dsp::SIMDRegister< Type >::vMaskSIMDType = typename vMaskType::vSIMDType

The internal native type for the corresponding mask type (used internally).

## CmplxOps

template<typename Type>

using juce::dsp::SIMDRegister< Type >::CmplxOps = CmplxSIMDOps<ElementType>

Wrapper for operations which need to be handled differently for complex and scalar types (used internally).

## Constructors and Destructors

## SIMDRegister() [1/3]

template<typename Type>

juce::dsp::SIMDRegister< Type >::SIMDRegister | ( |  | ) |

inline default noexcept

Default constructor.

## SIMDRegister() [2/3]

template<typename Type>

juce::dsp::SIMDRegister< Type >::SIMDRegister | ( | vSIMDType | a | ) |

inline noexcept

Constructs an object from the native SIMD type.

## SIMDRegister() [3/3]

template<typename Type>

juce::dsp::SIMDRegister< Type >::SIMDRegister | ( | Type | s | ) |

inline noexcept

Constructs an object from a scalar type by broadcasting it to all elements.

## Member Functions

## size()

template<typename Type>

constexpr size_t juce::dsp::SIMDRegister< Type >::size | ( |  | ) |

inline static constexpr noexcept

Returns the number of elements in this vector.

## expand()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::expand | ( | ElementType | s | ) |

inline static noexcept

Creates a new SIMDRegister from the corresponding scalar primitive.

The scalar is extended to all elements of the vector.

Referenced by juce::dsp::SIMDRegister< MaskType >::abs(), and juce::dsp::SIMDRegister< MaskType >::operator==().

## fromNative()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::fromNative | ( | vSIMDType | a | ) |

inline static noexcept

Creates a new SIMDRegister from the internal SIMD type (for example __mm128 for single-precision floating point on SSE architectures).

## fromRawArray()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::fromRawArray | ( | const ElementType * | a | ) |

inline static noexcept

Creates a new SIMDRegister from the first SIMDNumElements of a scalar array.

## copyToRawArray()

template<typename Type>

void JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::copyToRawArray | ( | ElementType * | a | ) | const

inline noexcept

Copies the elements of the SIMDRegister to a scalar array in memory.

## get()

template<typename Type>

ElementType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::get | ( | size_t | idx | ) | const

inline noexcept

Returns the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

Referenced by juce::dsp::SIMDRegister< MaskType >::operator[]().

## set()

template<typename Type>

void JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::set | ( | size_t | idx,
|  | ElementType | v )

inline noexcept

Sets the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

## operator[]() [1/2]

template<typename Type>

ElementType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator[] | ( | size_t | idx | ) | const

inline noexcept

Returns the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

## operator[]() [2/2]

template<typename Type>

ElementAccess JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator[] | ( | size_t | idx | ) |

inline noexcept

Returns the idx-th element of the receiver.

Note that this does not check if idx is larger than the native register size.

## operator+=() [1/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator+= | ( | SIMDRegister< Type > | v | ) |

inline noexcept

Adds another SIMDRegister to the receiver.

## operator-=() [1/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator-= | ( | SIMDRegister< Type > | v | ) |

inline noexcept

Subtracts another SIMDRegister to the receiver.

## operator*=() [1/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator*= | ( | SIMDRegister< Type > | v | ) |

inline noexcept

Multiplies another SIMDRegister to the receiver.

## operator=()

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator= | ( | ElementType | s | ) |

inline noexcept

Broadcasts the scalar to all elements of the receiver.

Referenced by juce::dsp::SIMDRegister< Type >::ElementAccess::operator=().

## operator+=() [2/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator+= | ( | ElementType | s | ) |

inline noexcept

Adds a scalar to the receiver.

## operator-=() [2/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator-= | ( | ElementType | s | ) |

inline noexcept

Subtracts a scalar to the receiver.

## operator*=() [2/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator*= | ( | ElementType | s | ) |

inline noexcept

Multiplies a scalar to the receiver.

## operator&=() [1/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator&= | ( | vMaskType | v | ) |

inline noexcept

Bit-and the receiver with SIMDRegister v and store the result in the receiver.

## operator|=() [1/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator|= | ( | vMaskType | v | ) |

inline noexcept

Bit-or the receiver with SIMDRegister v and store the result in the receiver.

## operator^=() [1/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator^= | ( | vMaskType | v | ) |

inline noexcept

Bit-xor the receiver with SIMDRegister v and store the result in the receiver.

## operator&=() [2/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator&= | ( | MaskType | s | ) |

inline noexcept

Bit-and each element of the receiver with the scalar s and store the result in the receiver.

## operator|=() [2/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator|= | ( | MaskType | s | ) |

inline noexcept

Bit-or each element of the receiver with the scalar s and store the result in the receiver.

## operator^=() [2/2]

template<typename Type>

SIMDRegister &JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator^= | ( | MaskType | s | ) |

inline noexcept

Bit-xor each element of the receiver with the scalar s and store the result in the receiver.

## operator+() [1/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator+ | ( | SIMDRegister< Type > | v | ) | const

inline noexcept

Returns the sum of the receiver and v.

## operator-() [1/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator- | ( | SIMDRegister< Type > | v | ) | const

inline noexcept

Returns the difference of the receiver and v.

## operator*() [1/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator* | ( | SIMDRegister< Type > | v | ) | const

inline noexcept

Returns the product of the receiver and v.

## operator+() [2/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator+ | ( | ElementType | s | ) | const

inline noexcept

Returns a vector where each element is the sum of the corresponding element in the receiver and the scalar s.

## operator-() [2/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator- | ( | ElementType | s | ) | const

inline noexcept

Returns a vector where each element is the difference of the corresponding element in the receiver and the scalar s.

## operator*() [2/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator* | ( | ElementType | s | ) | const

inline noexcept

Returns a vector where each element is the product of the corresponding element in the receiver and the scalar s.

## operator&() [1/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator& | ( | vMaskType | v | ) | const

inline noexcept

Returns the bit-and of the receiver and v.

## operator|() [1/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator| | ( | vMaskType | v | ) | const

inline noexcept

Returns the bit-or of the receiver and v.

## operator^() [1/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator^ | ( | vMaskType | v | ) | const

inline noexcept

Returns the bit-xor of the receiver and v.

## operator~()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator~ | ( |  | ) | const

inline noexcept

Returns a vector where each element is the bit-inverted value of the corresponding element in the receiver.

## operator&() [2/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator& | ( | MaskType | s | ) | const

inline noexcept

Returns a vector where each element is the bit-and'd value of the corresponding element in the receiver and the scalar s.

## operator|() [2/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator| | ( | MaskType | s | ) | const

inline noexcept

Returns a vector where each element is the bit-or'd value of the corresponding element in the receiver and the scalar s.

## operator^() [2/2]

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator^ | ( | MaskType | s | ) | const

inline noexcept

Returns a vector where each element is the bit-xor'd value of the corresponding element in the receiver and the scalar s.

## operator==() [1/2]

template<typename Type>

bool JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator== | ( | SIMDRegister< Type > | other | ) | const

inline noexcept

Returns true if all element-wise comparisons return true.

## operator!=() [1/2]

template<typename Type>

bool JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator!= | ( | SIMDRegister< Type > | other | ) | const

inline noexcept

Returns true if any element-wise comparisons return false.

## operator==() [2/2]

template<typename Type>

bool JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator== | ( | Type | s | ) | const

inline noexcept

Returns true if all elements are equal to the scalar.

## operator!=() [2/2]

template<typename Type>

bool JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::operator!= | ( | Type | s | ) | const

inline noexcept

Returns true if any elements are not equal to the scalar.

## equal()

template<typename Type>

vMaskType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::equal | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

## notEqual()

template<typename Type>

vMaskType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::notEqual | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is not equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

## lessThan()

template<typename Type>

vMaskType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::lessThan | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is less than to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

Referenced by juce::dsp::SIMDRegister< MaskType >::abs().

## lessThanOrEqual()

template<typename Type>

vMaskType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::lessThanOrEqual | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is than or equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

## greaterThan()

template<typename Type>

vMaskType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::greaterThan | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

## greaterThanOrEqual()

template<typename Type>

vMaskType JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::greaterThanOrEqual | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a SIMDRegister of the corresponding integral type where each element has each bit set if the corresponding element of a is greater than or equal to the corresponding element of b, or zero otherwise.

The result can then be used in bit operations defined above to avoid branches in vector SIMD code.

## min()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::min | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a new vector where each element is the minimum of the corresponding element of a and b.

Referenced by juce::jmin().

## max()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::max | ( | SIMDRegister< Type > | a,
|  | SIMDRegister< Type > | b )

inline static noexcept

Returns a new vector where each element is the maximum of the corresponding element of a and b.

Referenced by juce::jmax().

## multiplyAdd()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::multiplyAdd | ( | SIMDRegister< Type > | a,
|  | const SIMDRegister< Type > | b,
|  | SIMDRegister< Type > | c )

inline static noexcept

Multiplies b and c and adds the result to a.

## sum()

template<typename Type>

ElementType juce::dsp::SIMDRegister< Type >::sum | ( |  | ) | const

inline noexcept

Returns a scalar which is the sum of all elements of the receiver.

## truncate()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::truncate | ( | SIMDRegister< Type > | a | ) |

inline static noexcept

Truncates each element to its integer part.

Effectively discards the fractional part of each element. A.k.a. round to zero.

## abs()

template<typename Type>

SIMDRegister JUCE_VECTOR_CALLTYPE juce::dsp::SIMDRegister< Type >::abs | ( | SIMDRegister< Type > | a | ) |

inline static noexcept

Returns the absolute value of each element.

## isSIMDAligned()

template<typename Type>

bool juce::dsp::SIMDRegister< Type >::isSIMDAligned | ( | const ElementType * | ptr | ) |

inline static noexcept

Checks if the given pointer is sufficiently aligned for using SIMD operations.

## getNextSIMDAlignedPtr()

template<typename Type>

ElementType * juce::dsp::SIMDRegister< Type >::getNextSIMDAlignedPtr | ( | ElementType * | ptr | ) |

inline static noexcept

Returns the next position in memory where isSIMDAligned returns true.

If the current position in memory is already aligned then this method will simply return the pointer.

## Member Data Documentation

## SIMDRegisterSize

template<typename Type>

size_t juce::dsp::SIMDRegister< Type >::SIMDRegisterSize = sizeof (vSIMDType)

static constexpr

The size in bytes of this register.

## SIMDNumElements

template<typename Type>

size_t juce::dsp::SIMDRegister< Type >::SIMDNumElements = SIMDRegisterSize / sizeof (ElementType)

static constexpr

The number of elements that this vector can hold.

## value

template<typename Type>

vSIMDType juce::dsp::SIMDRegister< Type >::value {}

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited